package com.hai.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class HighDiscountExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public HighDiscountExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Long value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Long value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Long value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Long value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Long value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Long value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Long> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Long> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Long value1, Long value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Long value1, Long value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyIsNull() {
            addCriterion("discount_key is null");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyIsNotNull() {
            addCriterion("discount_key is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyEqualTo(String value) {
            addCriterion("discount_key =", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyNotEqualTo(String value) {
            addCriterion("discount_key <>", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyGreaterThan(String value) {
            addCriterion("discount_key >", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyGreaterThanOrEqualTo(String value) {
            addCriterion("discount_key >=", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyLessThan(String value) {
            addCriterion("discount_key <", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyLessThanOrEqualTo(String value) {
            addCriterion("discount_key <=", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyLike(String value) {
            addCriterion("discount_key like", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyNotLike(String value) {
            addCriterion("discount_key not like", value, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyIn(List<String> values) {
            addCriterion("discount_key in", values, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyNotIn(List<String> values) {
            addCriterion("discount_key not in", values, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyBetween(String value1, String value2) {
            addCriterion("discount_key between", value1, value2, "discountKey");
            return (Criteria) this;
        }

        public Criteria andDiscountKeyNotBetween(String value1, String value2) {
            addCriterion("discount_key not between", value1, value2, "discountKey");
            return (Criteria) this;
        }

        public Criteria andUsingRangeIsNull() {
            addCriterion("using_range is null");
            return (Criteria) this;
        }

        public Criteria andUsingRangeIsNotNull() {
            addCriterion("using_range is not null");
            return (Criteria) this;
        }

        public Criteria andUsingRangeEqualTo(Integer value) {
            addCriterion("using_range =", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeNotEqualTo(Integer value) {
            addCriterion("using_range <>", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeGreaterThan(Integer value) {
            addCriterion("using_range >", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeGreaterThanOrEqualTo(Integer value) {
            addCriterion("using_range >=", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeLessThan(Integer value) {
            addCriterion("using_range <", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeLessThanOrEqualTo(Integer value) {
            addCriterion("using_range <=", value, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeIn(List<Integer> values) {
            addCriterion("using_range in", values, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeNotIn(List<Integer> values) {
            addCriterion("using_range not in", values, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeBetween(Integer value1, Integer value2) {
            addCriterion("using_range between", value1, value2, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUsingRangeNotBetween(Integer value1, Integer value2) {
            addCriterion("using_range not between", value1, value2, "usingRange");
            return (Criteria) this;
        }

        public Criteria andUseScopeIsNull() {
            addCriterion("use_scope is null");
            return (Criteria) this;
        }

        public Criteria andUseScopeIsNotNull() {
            addCriterion("use_scope is not null");
            return (Criteria) this;
        }

        public Criteria andUseScopeEqualTo(Integer value) {
            addCriterion("use_scope =", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotEqualTo(Integer value) {
            addCriterion("use_scope <>", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeGreaterThan(Integer value) {
            addCriterion("use_scope >", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeGreaterThanOrEqualTo(Integer value) {
            addCriterion("use_scope >=", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeLessThan(Integer value) {
            addCriterion("use_scope <", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeLessThanOrEqualTo(Integer value) {
            addCriterion("use_scope <=", value, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeIn(List<Integer> values) {
            addCriterion("use_scope in", values, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotIn(List<Integer> values) {
            addCriterion("use_scope not in", values, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeBetween(Integer value1, Integer value2) {
            addCriterion("use_scope between", value1, value2, "useScope");
            return (Criteria) this;
        }

        public Criteria andUseScopeNotBetween(Integer value1, Integer value2) {
            addCriterion("use_scope not between", value1, value2, "useScope");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIsNull() {
            addCriterion("discount_name is null");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIsNotNull() {
            addCriterion("discount_name is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountNameEqualTo(String value) {
            addCriterion("discount_name =", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotEqualTo(String value) {
            addCriterion("discount_name <>", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameGreaterThan(String value) {
            addCriterion("discount_name >", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameGreaterThanOrEqualTo(String value) {
            addCriterion("discount_name >=", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLessThan(String value) {
            addCriterion("discount_name <", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLessThanOrEqualTo(String value) {
            addCriterion("discount_name <=", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameLike(String value) {
            addCriterion("discount_name like", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotLike(String value) {
            addCriterion("discount_name not like", value, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameIn(List<String> values) {
            addCriterion("discount_name in", values, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotIn(List<String> values) {
            addCriterion("discount_name not in", values, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameBetween(String value1, String value2) {
            addCriterion("discount_name between", value1, value2, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountNameNotBetween(String value1, String value2) {
            addCriterion("discount_name not between", value1, value2, "discountName");
            return (Criteria) this;
        }

        public Criteria andDiscountImgIsNull() {
            addCriterion("discount_img is null");
            return (Criteria) this;
        }

        public Criteria andDiscountImgIsNotNull() {
            addCriterion("discount_img is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountImgEqualTo(String value) {
            addCriterion("discount_img =", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgNotEqualTo(String value) {
            addCriterion("discount_img <>", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgGreaterThan(String value) {
            addCriterion("discount_img >", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgGreaterThanOrEqualTo(String value) {
            addCriterion("discount_img >=", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgLessThan(String value) {
            addCriterion("discount_img <", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgLessThanOrEqualTo(String value) {
            addCriterion("discount_img <=", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgLike(String value) {
            addCriterion("discount_img like", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgNotLike(String value) {
            addCriterion("discount_img not like", value, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgIn(List<String> values) {
            addCriterion("discount_img in", values, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgNotIn(List<String> values) {
            addCriterion("discount_img not in", values, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgBetween(String value1, String value2) {
            addCriterion("discount_img between", value1, value2, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountImgNotBetween(String value1, String value2) {
            addCriterion("discount_img not between", value1, value2, "discountImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgIsNull() {
            addCriterion("discount_carousel_img is null");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgIsNotNull() {
            addCriterion("discount_carousel_img is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgEqualTo(String value) {
            addCriterion("discount_carousel_img =", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgNotEqualTo(String value) {
            addCriterion("discount_carousel_img <>", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgGreaterThan(String value) {
            addCriterion("discount_carousel_img >", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgGreaterThanOrEqualTo(String value) {
            addCriterion("discount_carousel_img >=", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgLessThan(String value) {
            addCriterion("discount_carousel_img <", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgLessThanOrEqualTo(String value) {
            addCriterion("discount_carousel_img <=", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgLike(String value) {
            addCriterion("discount_carousel_img like", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgNotLike(String value) {
            addCriterion("discount_carousel_img not like", value, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgIn(List<String> values) {
            addCriterion("discount_carousel_img in", values, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgNotIn(List<String> values) {
            addCriterion("discount_carousel_img not in", values, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgBetween(String value1, String value2) {
            addCriterion("discount_carousel_img between", value1, value2, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountCarouselImgNotBetween(String value1, String value2) {
            addCriterion("discount_carousel_img not between", value1, value2, "discountCarouselImg");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIsNull() {
            addCriterion("discount_type is null");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIsNotNull() {
            addCriterion("discount_type is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeEqualTo(Integer value) {
            addCriterion("discount_type =", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotEqualTo(Integer value) {
            addCriterion("discount_type <>", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeGreaterThan(Integer value) {
            addCriterion("discount_type >", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("discount_type >=", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeLessThan(Integer value) {
            addCriterion("discount_type <", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeLessThanOrEqualTo(Integer value) {
            addCriterion("discount_type <=", value, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeIn(List<Integer> values) {
            addCriterion("discount_type in", values, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotIn(List<Integer> values) {
            addCriterion("discount_type not in", values, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeBetween(Integer value1, Integer value2) {
            addCriterion("discount_type between", value1, value2, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("discount_type not between", value1, value2, "discountType");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIsNull() {
            addCriterion("discount_condition is null");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIsNotNull() {
            addCriterion("discount_condition is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionEqualTo(BigDecimal value) {
            addCriterion("discount_condition =", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotEqualTo(BigDecimal value) {
            addCriterion("discount_condition <>", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionGreaterThan(BigDecimal value) {
            addCriterion("discount_condition >", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_condition >=", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionLessThan(BigDecimal value) {
            addCriterion("discount_condition <", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_condition <=", value, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionIn(List<BigDecimal> values) {
            addCriterion("discount_condition in", values, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotIn(List<BigDecimal> values) {
            addCriterion("discount_condition not in", values, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_condition between", value1, value2, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountConditionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_condition not between", value1, value2, "discountCondition");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIsNull() {
            addCriterion("discount_price is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIsNotNull() {
            addCriterion("discount_price is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceEqualTo(BigDecimal value) {
            addCriterion("discount_price =", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotEqualTo(BigDecimal value) {
            addCriterion("discount_price <>", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceGreaterThan(BigDecimal value) {
            addCriterion("discount_price >", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_price >=", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceLessThan(BigDecimal value) {
            addCriterion("discount_price <", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("discount_price <=", value, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceIn(List<BigDecimal> values) {
            addCriterion("discount_price in", values, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotIn(List<BigDecimal> values) {
            addCriterion("discount_price not in", values, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_price between", value1, value2, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andDiscountPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("discount_price not between", value1, value2, "discountPrice");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberIsNull() {
            addCriterion("receive_number is null");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberIsNotNull() {
            addCriterion("receive_number is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberEqualTo(Integer value) {
            addCriterion("receive_number =", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberNotEqualTo(Integer value) {
            addCriterion("receive_number <>", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberGreaterThan(Integer value) {
            addCriterion("receive_number >", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberGreaterThanOrEqualTo(Integer value) {
            addCriterion("receive_number >=", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberLessThan(Integer value) {
            addCriterion("receive_number <", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberLessThanOrEqualTo(Integer value) {
            addCriterion("receive_number <=", value, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberIn(List<Integer> values) {
            addCriterion("receive_number in", values, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberNotIn(List<Integer> values) {
            addCriterion("receive_number not in", values, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberBetween(Integer value1, Integer value2) {
            addCriterion("receive_number between", value1, value2, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andReceiveNumberNotBetween(Integer value1, Integer value2) {
            addCriterion("receive_number not between", value1, value2, "receiveNumber");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayIsNull() {
            addCriterion("effective_day is null");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayIsNotNull() {
            addCriterion("effective_day is not null");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayEqualTo(Integer value) {
            addCriterion("effective_day =", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayNotEqualTo(Integer value) {
            addCriterion("effective_day <>", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayGreaterThan(Integer value) {
            addCriterion("effective_day >", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayGreaterThanOrEqualTo(Integer value) {
            addCriterion("effective_day >=", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayLessThan(Integer value) {
            addCriterion("effective_day <", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayLessThanOrEqualTo(Integer value) {
            addCriterion("effective_day <=", value, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayIn(List<Integer> values) {
            addCriterion("effective_day in", values, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayNotIn(List<Integer> values) {
            addCriterion("effective_day not in", values, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayBetween(Integer value1, Integer value2) {
            addCriterion("effective_day between", value1, value2, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andEffectiveDayNotBetween(Integer value1, Integer value2) {
            addCriterion("effective_day not between", value1, value2, "effectiveDay");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeIsNull() {
            addCriterion("sales_end_time is null");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeIsNotNull() {
            addCriterion("sales_end_time is not null");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeEqualTo(Date value) {
            addCriterion("sales_end_time =", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeNotEqualTo(Date value) {
            addCriterion("sales_end_time <>", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeGreaterThan(Date value) {
            addCriterion("sales_end_time >", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("sales_end_time >=", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeLessThan(Date value) {
            addCriterion("sales_end_time <", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeLessThanOrEqualTo(Date value) {
            addCriterion("sales_end_time <=", value, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeIn(List<Date> values) {
            addCriterion("sales_end_time in", values, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeNotIn(List<Date> values) {
            addCriterion("sales_end_time not in", values, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeBetween(Date value1, Date value2) {
            addCriterion("sales_end_time between", value1, value2, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andSalesEndTimeNotBetween(Date value1, Date value2) {
            addCriterion("sales_end_time not between", value1, value2, "salesEndTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNull() {
            addCriterion("operator_id is null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIsNotNull() {
            addCriterion("operator_id is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorIdEqualTo(Long value) {
            addCriterion("operator_id =", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotEqualTo(Long value) {
            addCriterion("operator_id <>", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThan(Long value) {
            addCriterion("operator_id >", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdGreaterThanOrEqualTo(Long value) {
            addCriterion("operator_id >=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThan(Long value) {
            addCriterion("operator_id <", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdLessThanOrEqualTo(Long value) {
            addCriterion("operator_id <=", value, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdIn(List<Long> values) {
            addCriterion("operator_id in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotIn(List<Long> values) {
            addCriterion("operator_id not in", values, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdBetween(Long value1, Long value2) {
            addCriterion("operator_id between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorIdNotBetween(Long value1, Long value2) {
            addCriterion("operator_id not between", value1, value2, "operatorId");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNull() {
            addCriterion("operator_name is null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIsNotNull() {
            addCriterion("operator_name is not null");
            return (Criteria) this;
        }

        public Criteria andOperatorNameEqualTo(String value) {
            addCriterion("operator_name =", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotEqualTo(String value) {
            addCriterion("operator_name <>", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThan(String value) {
            addCriterion("operator_name >", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameGreaterThanOrEqualTo(String value) {
            addCriterion("operator_name >=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThan(String value) {
            addCriterion("operator_name <", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLessThanOrEqualTo(String value) {
            addCriterion("operator_name <=", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameLike(String value) {
            addCriterion("operator_name like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotLike(String value) {
            addCriterion("operator_name not like", value, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameIn(List<String> values) {
            addCriterion("operator_name in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotIn(List<String> values) {
            addCriterion("operator_name not in", values, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameBetween(String value1, String value2) {
            addCriterion("operator_name between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andOperatorNameNotBetween(String value1, String value2) {
            addCriterion("operator_name not between", value1, value2, "operatorName");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}